package com.google.android.glass.sample.stopwatch;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.google.android.glass.timeline.DirectRenderingCallback;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.hardware.Camera;
import android.hardware.Camera.Parameters;
import android.media.CamcorderProfile;
import android.media.MediaRecorder;
import android.os.Environment;
import android.os.SystemClock;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceHolder.Callback;
import android.view.SurfaceView;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.Toast;
import android.widget.FrameLayout.LayoutParams;


public class ChronometerDrawer implements Callback {//DirectRenderingCallback
	Camera mCamera;
	MediaRecorder recorder;
	CaptureThread ct;

	SurfaceView view;
	Parameters parameters;
	SurfaceHolder sHolder;
	
	View cardView;
	Toast startRecording;
	Toast stopRecording;
	Toast tictack;
	boolean isRecording=false;
	boolean videoMode=true;

	String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());
	String externalPath;
	{
		if(!videoMode){
			externalPath = Environment.getExternalStorageDirectory()+ File.separator + "DCIM/Camera/Pic_"+timeStamp+".jpg";
		}else{
			externalPath = Environment.getExternalStorageDirectory()+ File.separator + "DCIM/Camera/Vid_"+timeStamp+".mp4";
		}
	}
	
	
    public void StopCapturing(){
    	if(!videoMode){
        	ct.stopRunning();
    	}else {
		   	recorder.stop();
		   	recorder.release();
		}
    	mCamera.stopPreview();
        mCamera.release();
        mCamera=null;
    }
    
    Camera.PictureCallback jpegCallBack=new Camera.PictureCallback() {
	    public void onPictureTaken(byte[] data, Camera camera) {
            tictack.show();
	    	long today = System.currentTimeMillis();
        	
			File destination = new File(externalPath);
	        try {
	            Bitmap userImage = BitmapFactory.decodeByteArray(data, 0, data.length);
	            FileOutputStream out = new FileOutputStream(destination);
	            userImage.compress(Bitmap.CompressFormat.JPEG, 90, out);        
	
	        } catch (FileNotFoundException e) {
	            e.printStackTrace();
	        }
	    }
	};

    public ChronometerDrawer(Context context) {
	     if(recorder==null)
	   		    recorder = new MediaRecorder();
	     
 	   startRecording = Toast.makeText(context, "Start Recording!", Toast.LENGTH_SHORT);
 	   stopRecording = Toast.makeText(context, "Stop Recording!", Toast.LENGTH_SHORT);
 	   tictack = Toast.makeText(context, "tick tock!", Toast.LENGTH_SHORT);
        
        LinearLayout.LayoutParams params =  new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT);
		view = new SurfaceView(context);
		view.setLayoutParams(params);
	   	sHolder = view.getHolder();
	   	sHolder.addCallback(this);  

	     
	   	if(!videoMode){
    	   ct = new CaptureThread();
    	   ct.start();
	   	}else{
		   	//initRecorder();
	        //recorder.start();
	   	}
    }

    @Override
    public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
//		 parameters = mCamera.getParameters();
//	     mCamera.setParameters(parameters);
    }

	@Override
    public void surfaceCreated(SurfaceHolder holder) {
       if(!videoMode){
    	   if(mCamera==null)
   	      	mCamera = Camera.open();
	        
	         try {
	      	   mCamera.setPreviewDisplay(holder);
	  		} catch (IOException e) {
	  			e.printStackTrace();
	  		}
	         mCamera.startPreview();
	   	}else{
		   if(mCamera==null)
	      		mCamera = Camera.open();
  	     
		   Camera.Parameters params = mCamera.getParameters();
	        params.setRecordingHint(true);
	        mCamera.setParameters(params);
	        
	       try {
	    	   mCamera.setPreviewDisplay(holder);
		         mCamera.startPreview();
		         mCamera.unlock();
			       recorder.setCamera(mCamera);

					recorder.setAudioSource(MediaRecorder.AudioSource.CAMCORDER);
					recorder.setVideoSource(MediaRecorder.VideoSource.CAMERA);
	                recorder.setProfile(CamcorderProfile.get(CamcorderProfile.QUALITY_720P));

		          recorder.setOutputFile(externalPath);
			       
		        recorder.setPreviewDisplay(holder.getSurface());
	    	   recorder.prepare();
	       		recorder.start();
	       	} catch (IllegalStateException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

	   	}
       
    }
    
    @Override
    public void surfaceDestroyed(SurfaceHolder holder) {
	       Log.d("test", "6");
//	   	recorder.stop();
//	   	recorder.release();
        sHolder = null;
    }

    
    class CaptureThread extends Thread{
	    int counter = 0;
	    boolean running = true;
	    void stopRunning(){
	    	running = false;
	    }
		
		@Override
		public void run() {
			super.run();
			while(running){
				try {
					Thread.sleep(5000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				counter++;
				//if(mCamera!=null){
				     //mCamera.startPreview();
				     mCamera.takePicture(null, null, jpegCallBack);
				//}
			     Log.d("test", "count: "+counter);
			}
		}
	}

}

